diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index 2a1331a24..241dada68 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -11,6 +11,7 @@ import net.minecraft.client.gui.achievements.data.AchievementPages;
 import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -415,9 +416,8 @@ public class ScreenAchievements extends Screen
             drawPagesListScrollBar(mx, my);
 
             if (hoveredPage != null){
-                String msg = font.wrapFormattedStringToWidth(hoveredPage.getDescription(), TOOLTIP_BOX_WIDTH_MIN);
-                msg += "\n" + TextFormatting.LIGHT_GRAY + I18n.getInstance().translateKeyAndFormat("gui.achievements.label.completion",  Math.round(hoveredPage.getCompletionFraction(statsCounter) * 100) + "%");
-                tooltip.render(msg, mx, my, TOOLTIP_OFF_X, TOOLTIP_OFF_Y);
+                final String msg = this.hoveredPage.getDescription() + "\n" + TextFormatting.LIGHT_GRAY + I18n.getInstance().translateKeyAndFormat("gui.achievements.label.completion",  Math.round(hoveredPage.getCompletionFraction(statsCounter) * 100) + "%");
+                this.tooltip.render(msg, mx, my, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, TOOLTIP_BOX_WIDTH_MIN, -1, true);
             }
         }
 
@@ -445,7 +445,7 @@ public class ScreenAchievements extends Screen
     }
 
     protected void renderLabels() {
-        font.drawCenteredString(I18n.getInstance().translateKey("gui.achievements.label.title")/* + " " + viewportZoom + " X:" + currentShiftX + ", Y:" + currentShiftY*/, width/2, 5 , 0xFFFFFF);
+        drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey("gui.achievements.label.title")/* + " " + viewportZoom + " X:" + currentShiftX + ", Y:" + currentShiftY*/, width/2, 5 , 0xFFFFFF);
     }
 
 
@@ -856,25 +856,25 @@ public class ScreenAchievements extends Screen
         final int padding = tooltip.getPadding();
         int[] boxRender;
         if(statsCounter.canUnlock(achievement)) { // Can unlock/ is unlocked
-            int boxWidth = Math.max(font.getStringWidth(name), TOOLTIP_BOX_WIDTH_MIN);
-            int boxHeight = font.getHeightOfConstrainedString(desc, boxWidth);
+            int boxWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(name)), TOOLTIP_BOX_WIDTH_MIN);
+            int boxHeight = MathHelper.ceil(this.fontRenderer.heightOfConstrainedChars(desc, boxWidth));
             if(statsCounter.isUnlocked(achievement)) {
                 boxHeight += 12;
             }
             boxRender = tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
-            font.drawStringIntoConstrainedBlock(desc, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth, 0xffa0a0a0);
+            FontHelper.renderWidthConstrained(Tessellator.instance, desc, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xffa0a0a0).call(this.fontRenderer);
             if(statsCounter.isUnlocked(achievement)) { // Add taken string to bottom
-                font.drawStringWithShadow(I18n.getInstance().translateKey("gui.achievements.label.taken"), boxRender[0] + padding, boxRender[1] + boxHeight + 8 + padding, 0xff9090ff);
+                drawStringShadow(fontRenderer, I18n.getInstance().translateKey("gui.achievements.label.taken"), boxRender[0] + padding, boxRender[1] + boxHeight + 8 + padding, 0xff9090ff);
             }
         } else { // Not unlocked so darken
-            int boxWidth = Math.max(font.getStringWidth(name), TOOLTIP_BOX_WIDTH_MIN);
+            int boxWidth = Math.max(MathHelper.ceil(fontRenderer.stringWidthDouble(name)), TOOLTIP_BOX_WIDTH_MIN);
             String msg = I18n.getInstance().translateKeyAndFormat("gui.achievements.label.requires", achievement.parent.getStatName());
-            int boxHeight = font.getHeightOfConstrainedString(msg, boxWidth);
+            int boxHeight = MathHelper.ceil(fontRenderer.heightOfConstrainedChars(msg, boxWidth));
             boxRender = tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
-            font.drawStringIntoConstrainedBlock(msg, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth, 0xff705050);
+            FontHelper.renderWidthConstrained(Tessellator.instance, msg, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xff705050).call(this.fontRenderer);
         }
         int color = statsCounter.canUnlock(achievement) ? achievement.getType().colorName : achievement.getType().colorNameLocked;
-        font.drawStringWithShadow(name, boxRender[0] + padding, boxRender[1] + padding, color);
+        drawStringShadow(fontRenderer, name, boxRender[0] + padding, boxRender[1] + padding, color);
     }
     public boolean drawSidebar(){
         return AchievementPageRegistry.getInstance().getPages().size() > 1;
@@ -914,7 +914,7 @@ public class ScreenAchievements extends Screen
                 GL11.glColor4f(1f, 1f, 1f, 1f);
                 drawGuiIcon(x + 8, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9 + 8, 11, 11, TextureRegistry.getTexture("minecraft:gui/screen/achievement/star"));
             }
-            mc.font.drawStringWithShadow(name, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
+            drawStringShadow(this.fontRenderer, name, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
index ab644a0eb..7d95ca20e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
@@ -125,6 +125,6 @@ public class GuiElementChatEmotePicker extends Gui {
             color = 0xffffffa0;
         }
 
-        drawStringCentered(mc.font, String.valueOf(c), x + CELL_WIDTH / 2, y + (CELL_HEIGHT / 2 - 4), color);
+        drawStringCenteredShadow(mc.font, String.valueOf(c), x + CELL_WIDTH / 2, y + (CELL_HEIGHT / 2 - 4), color);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index fa1b9f38d..8c7501e44 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -21,7 +21,9 @@ import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.net.command.ClientCommandSource;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.command.*;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.packet.PacketRequestCommandManager;
@@ -44,7 +46,7 @@ public class GuiElementChatSuggestions extends Gui {
     private final TextFieldEditor editor;
     private final ITextField textField;
     private final Minecraft mc;
-    private final Font fontRenderer;
+    private final FontRenderer fontRenderer;
     private final CommandSource commandSource;
     private final PositionSupplier<Integer> xSupplier;
     private final PositionSupplier<Integer> ySupplier;
@@ -129,7 +131,7 @@ public class GuiElementChatSuggestions extends Gui {
         }
     }
 
-    private void renderSuggestions(Font fontRenderer, String message, int start) {
+    private void renderSuggestions(FontRenderer fontRenderer, String message, int start) {
         int mouseX = getScaledMouseX(this.mc);
         int mouseY = getScaledMouseY(this.mc) - 1;
 
@@ -137,8 +139,8 @@ public class GuiElementChatSuggestions extends Gui {
 
         int largestSuggestion = 0;
         for (Suggestion suggestion : this.suggestions)
-            if (fontRenderer.getStringWidth(suggestion.getText()) > largestSuggestion)
-                largestSuggestion = fontRenderer.getStringWidth(suggestion.getText());
+            if (fontRenderer.stringWidth(suggestion.getText()) > largestSuggestion)
+                largestSuggestion = fontRenderer.stringWidth(suggestion.getText());
 
         leftMargin -= (int) (this.anchor.xPosition * (largestSuggestion + 2));
 
@@ -163,9 +165,9 @@ public class GuiElementChatSuggestions extends Gui {
                 colorCode = TextFormatting.LIGHT_GRAY.toString();
             }
 
-            int textX = (int) (leftMargin + 1 + (this.anchor.xPosition * (largestSuggestion - fontRenderer.getStringWidth(suggestionText))));
+            int textX = (int) (leftMargin + 1 + (this.anchor.xPosition * (largestSuggestion - fontRenderer.stringWidth(suggestionText))));
 
-            fontRenderer.drawStringWithShadow(colorCode + suggestionText, textX, minY + suggestionBoxHeight - suggestionHeight + 3, 0xE0E0E0);
+            FontHelper.render(Tessellator.instance, colorCode + suggestionText, textX, minY + suggestionBoxHeight - suggestionHeight + 3).setShadow().setColor(0xE0E0E0).call(fontRenderer);
         }
 
         if (this.isHoveringOverSuggestions(mouseX, mouseY) && this.suggestions.get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get()).getTooltip() != null) {
@@ -173,9 +175,9 @@ public class GuiElementChatSuggestions extends Gui {
         }
     }
 
-    private void renderSingleSuggestionLine(Font fontRenderer, String text, int heightIndex, boolean followParameters) {
+    private void renderSingleSuggestionLine(FontRenderer fontRenderer, String text, int heightIndex, boolean followParameters) {
         int leftMargin = this.xSupplier.get(this.textField, this, this.mc, SUGGESTIONS_FOLLOW_PARAMETERS && followParameters);
-        int stringWidth = fontRenderer.getStringWidth(text);
+        int stringWidth = fontRenderer.stringWidth(text);
 
         leftMargin -= (int) (this.anchor.xPosition * (stringWidth + 2));
 
@@ -184,7 +186,7 @@ public class GuiElementChatSuggestions extends Gui {
         minY += (int) CommandHelper.linearInterpolation(this.anchor.yPosition, heightIndex * 12, -12 - heightIndex * 12);
 
         this.drawRect(leftMargin, minY, stringWidth + leftMargin + 1, minY + 12, Integer.MIN_VALUE);
-        fontRenderer.drawStringWithShadow(text, leftMargin + 1, minY + 2, 0xE0E0E0);
+        FontHelper.render(Tessellator.instance, text, leftMargin + 1, minY + 2).setShadow().setColor(0xE0E0E0).call(fontRenderer);
     }
 
     private List<String> getCommandUsage(int cursor) {
@@ -306,8 +308,8 @@ public class GuiElementChatSuggestions extends Gui {
 
         int largestSuggestion = 0;
         for (Suggestion suggestion : this.suggestions)
-            if (this.fontRenderer.getStringWidth(suggestion.getText()) > largestSuggestion)
-                largestSuggestion = this.fontRenderer.getStringWidth(suggestion.getText());
+            if (this.fontRenderer.stringWidth(suggestion.getText()) > largestSuggestion)
+                largestSuggestion = this.fontRenderer.stringWidth(suggestion.getText());
 
         minX -= (int) (this.anchor.xPosition * (largestSuggestion + 2));
 
@@ -501,7 +503,7 @@ public class GuiElementChatSuggestions extends Gui {
     }
 
     public int getDefaultParameterPosition() {
-        return this.fontRenderer.getStringWidth(this.getMessage().substring(0, Math.min(this.getSuggestionRangeStart(), this.getMessage().length()))) + 2;
+        return this.fontRenderer.stringWidth(this.getMessage().substring(0, Math.min(this.getSuggestionRangeStart(), this.getMessage().length()))) + 2;
     }
 
     public static void drawDottedRect(Gui gui, int minX, int minY, int maxX, int maxY, int argb, int dotSize) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
index 26d4e249a..9b086d5b7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
@@ -195,22 +195,22 @@ public class ScreenChat extends Screen implements ITextField {
 				emotePickerTextColor = 0xffffffa0;
 			}
 			drawRect(2, height - 14, 14, height - 2, emotePickerButtonColor);
-			drawStringCentered(font, Character.toString('\u263a'), 2 + 6, height - 12, emotePickerTextColor);
+			drawStringCenteredShadow(fontRenderer, Character.toString('\u263a'), 2 + 6, height - 12, emotePickerTextColor);
 
 			drawRect(16, height - 14, width - 2, height - 2, 0x80000000);
 
-			font.drawStringWithShadow(this.suggestionsElement.getSuggestionPreview(), 16 + suggestionsElement.getDefaultParameterPosition(), mc.resolution.getScaledHeightScreenCoords() - 12, 0xFFFFFF);
+			drawStringShadow(fontRenderer, this.suggestionsElement.getSuggestionPreview(), 16 + suggestionsElement.getDefaultParameterPosition(), mc.resolution.getScaledHeightScreenCoords() - 12, 0xFFFFFF);
 			boolean drawCursor = (updateCounter / 6) % 2 == 0;
 			int cursor = editor.getCursor();
-			drawString(font, this.suggestionsElement.colorCodeText(message, true), 18, height - 12, 0xE0E0E0);
+			drawStringShadow(fontRenderer, this.suggestionsElement.colorCodeText(message, true), 18, height - 12, 0xE0E0E0);
 			if (drawCursor)
 			{
-				int width = font.getStringWidth(message);
+				int width = MathHelper.ceil(fontRenderer.stringWidthDouble(message));
 				if (cursor < message.length())
 				{
-					width = font.getStringWidth(message.substring(0, cursor));
+					width = MathHelper.ceil(fontRenderer.stringWidthDouble(message.substring(0, cursor)));
 				}
-				drawString(font, "_", 18 + width, height - 12, 0xE0E0E0);
+				drawStringShadow(fontRenderer, "_", 18 + width, height - 12, 0xE0E0E0);
 			}
 
 			if (showEmotePicker) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
index 4f2ecc8fb..e6e332b24 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
@@ -55,8 +55,8 @@ public class ScreenActivator extends ScreenContainerAbstract {
 
     @Override
     protected void drawGuiContainerForegroundLayer() {
-        font.drawString(I18n.getInstance().translateKey("gui.activator.label.activator"), 60, 6, 0x404040);
-        font.drawString(I18n.getInstance().translateKey("gui.activator.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.activator.label.activator"), 60, 6, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.activator.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
index f69be2941..e925eb97d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
@@ -23,8 +23,8 @@ public class ScreenContainer extends ScreenContainerAbstract
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        font.drawString(I18n.getInstance().translateKey(lowerChestInventory.getNameTranslationKey()), 8, 6, 0x404040);
-        font.drawString(I18n.getInstance().translateKey(upperChestInventory.getNameTranslationKey()), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey(lowerChestInventory.getNameTranslationKey()), 8, 6, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey(upperChestInventory.getNameTranslationKey()), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
index 6b8c91681..a8cd96504 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
@@ -24,8 +24,8 @@ public class ScreenCrafting extends ScreenContainerAbstract
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        font.drawString(I18n.getInstance().translateKey("gui.crafting.label.crafting"), 28, 6, 0x404040);
-        font.drawString(I18n.getInstance().translateKey("gui.crafting.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.crafting.label.crafting"), 28, 6, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.crafting.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
index 8173f109f..1e4b74938 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
@@ -17,8 +17,8 @@ public class ScreenDispenser extends ScreenContainerAbstract
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        font.drawString(I18n.getInstance().translateKey("gui.dispenser.label.dispenser"), 60, 6, 0x404040);
-        font.drawString(I18n.getInstance().translateKey("gui.dispenser.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.dispenser.label.dispenser"), 60, 6, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.dispenser.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index 37e00bc48..e1f9ba18d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -402,7 +402,7 @@ public class ScreenFlagEditor
 
     @Override
     protected void drawGuiContainerForegroundLayer() {
-        font.drawString(I18n.getInstance().translateKey("gui.edit_flag.label.inventory"), 8, (ySize - 96) + 2, 0xFF404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.edit_flag.label.inventory"), 8, (ySize - 96) + 2, 0xFF404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
index 450a74d81..7b4cbf4c2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
@@ -22,11 +22,11 @@ public class ScreenFurnace extends ScreenContainerAbstract
     {
         I18n i18n = I18n.getInstance();
         if(furnaceInventory instanceof TileEntityFurnaceBlast) {
-            font.drawString(i18n.translateKey("gui.furnace.blast.label.blast_furnace"), 60, 6, 0x404040);
+            drawStringNoShadow(this.fontRenderer, i18n.translateKey("gui.furnace.blast.label.blast_furnace"), 60, 6, 0x404040);
         } else {
-            font.drawString(i18n.translateKey("gui.furnace.label.furnace"), 60, 6, 0x404040);
+            drawStringNoShadow(this.fontRenderer, i18n.translateKey("gui.furnace.label.furnace"), 60, 6, 0x404040);
         }
-        font.drawString(i18n.translateKey("gui.furnace.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, i18n.translateKey("gui.furnace.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index 72750dbf2..776ac4e5d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -141,7 +141,7 @@ public class ScreenInventory extends ScreenContainerAbstract
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        font.drawString(I18n.getInstance().translateKey("gui.inventory.label.crafting"), 86, 16, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.inventory.label.crafting"), 86, 16, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
index 15040ad0b..a41a7ab13 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.container;
 
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.TextFieldElement;
-import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
@@ -45,7 +44,7 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
 		buttons.add(lastPageButton = new ButtonElement(500, 0, 0, 20, 20, "<"));
 		buttons.add(nextPageButton = new ButtonElement(501, 0, 0, 20, 20, ">"));
 		buttons.add(clearSearchButton = new OptionsButtonElement(0, 0, 10, 12, 20, "").setTextures("minecraft:gui/screen/creative/clear", "minecraft:gui/screen/creative/clear_highlighted", null));
-		searchField = new TextFieldElement(this, font, 0, 0, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
+		searchField = new TextFieldElement(this, fontRenderer, 0, 0, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
 		searchField.drawBackground =false;
 		searchField.setMaxStringLength(14);
 		searchField.setTextChangeListener(this);
@@ -168,7 +167,7 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
 	protected void drawGuiContainerForegroundLayer()
     {
     	super.drawGuiContainerForegroundLayer();
-    	drawStringCenteredNoShadow(font, pageString, 238, 146, 0x404040);
+    	drawStringCenteredNoShadow(fontRenderer, pageString, 238, 146, 0x404040);
     }
 	
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java
index e769aeb28..3319ff80d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java
@@ -19,8 +19,8 @@ public class ScreenTrommel extends ScreenContainerAbstract
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        font.drawString(I18n.getInstance().translateKey("gui.trommel.label.trommel"), 60, 6, 0x404040);
-        font.drawString(I18n.getInstance().translateKey("gui.trommel.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.trommel.label.trommel"), 60, 6, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.trommel.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
index b5de2a188..cb571c2f0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
@@ -3,7 +3,7 @@ package net.minecraft.client.gui.createworld;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.paged.PageComponent;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -42,16 +42,15 @@ public abstract class ButtonComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
     {
-        Font fr = mc.font;
         String translated = I18n.getInstance().translateKey(translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
-        fr.drawStringWithShadow(translated, x, y + (getHeight() / 2) - 4, textColor);
+        FontHelper.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call(mc.font);
         resetButton.enabled = !isDefault();
         renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
-        int stringWidth = fr.getStringWidth(translated);
+        int stringWidth = mc.font.stringWidth(translated);
         int lineMaxX = x + width - BUTTON_WIDTH - 8;
         if (resetButton.enabled) lineMaxX -= 20;
         drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java b/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
index c4c869d85..f0318cdd6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
@@ -4,9 +4,8 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.gui.paged.CallbackComponent;
 import net.minecraft.client.gui.paged.OnValueChangedCallback;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -49,14 +48,13 @@ public class TextFieldComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
     {
-        Font fr = mc.font;
         String translated = I18n.getInstance().translateKey(translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
-        fr.drawStringWithShadow(translated, x, y + (getHeight() / 2) - 4, textColor);
-        int stringWidth = fr.getStringWidth(translated);
+        FontHelper.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call(mc.font);
+        int stringWidth = mc.font.stringWidth(translated);
         int lineMaxX = x + width - BUTTON_WIDTH - 8;
         drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
index c46fc54f6..439660536 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.guidebook;
 
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.Color;
 import org.lwjgl.opengl.GL11;
@@ -27,18 +27,18 @@ public abstract class GuidebookPage
         drawTexturedModalRect(x, y, 0, 0, width, height);
     }
 
-    protected abstract void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks);
+    protected abstract void renderForeground(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks);
 
     public boolean drawHeaders() {
         return true;
     }
 
-    public void render(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    public void render(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         renderBackground(re, x, y);
-        renderForeground(re, fr, x, y, mouseX, mouseY, partialTicks);
+        renderForeground(re, sr, x, y, mouseX, mouseY, partialTicks);
     }
 
-    protected void renderOverlay(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) { };
+    protected void renderOverlay(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) { };
 
     public void onMouseDown(int x, int y, int mouseX, int mouseY, int button) { }
 
